;***************************************************************************
;*			80286 ASM-file for filepacking
;*
;* (reading this in 2023: why the heck is this written in amateurish assembly!?)

;; Copyright (c) 1997 David Kuehling

;; This software is provided 'as-is', without any express or implied
;; warranty. In no event will the authors be held liable for any damages
;; arising from the use of this software.

;; Permission is granted to anyone to use this software for any purpose,
;; including commercial applications, and to alter it and redistribute it
;; freely, subject to the following restrictions:

;; 1. The origin of this software must not be misrepresented; you must not
;;    claim that you wrote the original software. If you use this software
;;    in a product, an acknowledgment in the product documentation would be
;;    appreciated but is not required.
;; 2. Altered source versions must be plainly marked as such, and must not be
;;    misrepresented as being the original software.
;; 3. This notice may not be removed or altered from any source distribution.
;***************************************************************************

;----------------------------------------------------------------------
	IDEAL
	LOCALS	@@
	MODEL	compact
	P286N
;----------------------------------------------------------------------

;----------------------------------------------------------------------
	DATASEG
OutPos		dw	0		;Aktuelle Position in OutBuffer
OutBit		db	0               ;Aktuelles Bit in OutBuffer
InPos		dw	0		;Aktuelle Position in InBuffer
InBit		db	0		;Aktuelles Bit in InBuffer
AddHuff		dw	0, -1, -1, 1, 1, 5, 5, 13, 13, 29, 29, 61, 61, 125, 125, 253
					;Additionswert zur Anpassung der Huff-
					;man Nummern an eineindeutige Zeichen-
					;nummern
;----------------------------------------------------------------------

;----------------------------------------------------------------------
	UDATASEG
ChrFreq		dd	256 dup (?)	;Buchstabenhufigkeitstabelle
OrdChrTbl	db	256 dup (?)	;Buchstaben nach Hufigkeit sort.
TransTbl	dw	256 dup (?)	;bersetzungstabelle
TransLen	db	256 dup (?)	;Lnge der Huffman-Zeichen
FileTbl		db	132 dup (?)	;bersetungstabell fr Datei
KnownChr	db	256 dup (?)	;Tabelle der bereits init. Zeichen
					; - fr CreateUnPackTbl
;----------------------------------------------------------------------

;----------------------------------------------------------------------
	UFARDATA InBufSeg
InBuffer	db	65535 dup (?)	;Einlese-Puffer

	UFARDATA OutBufSeg
OutBuffer	db	65535 dup (?)	;Ausgabe-Puffer
;----------------------------------------------------------------------


	CODESEG

;----------------------------------------------------------------------
EXTRN	_read: PROC, _write: PROC, _lseek: PROC
PUBLIC	_getChrFreq, _getOrdChrTbl, _CreateTransTbl, _WriteBits, _PackOneFile,\
	_CreateUnPackTbl, _ReadBits, _UnPackBlock, _UnPackOneFile
;----------------------------------------------------------------------

;----------------------------------------------------------------------
			;(int) read(handle, &buf, (unsigned)len);
MACRO	READ handle, offsbuf, segbuf, len
	push	len
	push	segbuf
	push	offsbuf
	push	handle
	call	_read
	add	sp, 8
ENDM
			;int write (Handle, &Buf, len)
MACRO	WRITE handle, offsbuf, segbuf, len
	push	len
	push	segbuf
	push	offsbuf
	push	handle
	call	_write
	add	sp, 8
ENDM
			;lseek (Handle, (long) Offset, fromwhere)
MACRO	LSEEK handle, offsl, offsh, fromwhere
	push	fromwhere
	push    offsh
	push	offsl
	push	handle
	call	_lseek
	add	sp, 8
ENDM

			;long getChrFreq (int FileHand, long *ChrFreqTbl)
MACRO	GETCHRFREQ handle, offstbl, segtbl
	push	segtbl
	push	offstbl
	push	handle
	call	_getChrFreq
	add	sp, 6
ENDM
			;getOrdChrTbl (long *ChrFreq, char *OrdChrTbl)
MACRO	GETORDCHRTBL offsfreq, segfreq, offsord, segord
	push	segord
	push	offsord
	push	segfreq
	push	offsfreq
	call	_getOrdChrTbl
	add	sp, 8
ENDM
			;CreateTransTbl (char *ChrOrdTbl, unsigned *TransTbl,
			;		char *TransLen, char *FileTbl)
MACRO	CREATETRANSTBL offsord, segord, offstrans, segtrans, offslen, seglen, offstbl, segtbl
	push	segtbl
	push	offstbl
	push	seglen
	push	offslen
	push	segtrans
	push	offstrans
	push	segord
	push	offsord
	call	_CreateTransTbl
	add	sp, 12
ENDM
			;WriteBits (char *Out, unsigned Value,
			;		unsigned Length)
MACRO	WRITEBITS offsout, segout, value, length
	push	length
	push	value
	push	segout
	push	offsout
	call	_WriteBits
	add	sp, 8
ENDM
			;getHuffStrLen (char far *str, unsigend length, char far *TransLen)
MACRO  	GETHUFFSTRLEN offsstr, segstr, length, offslen, seglen
	push	seglen
	push	offslen
	push	length
	push	segstr
	push	offsstr
	call	_GetHuffStrLen
	add	sp, 10
ENDM
			;PackBlock (char *In, char *Out, unsigned *TransTbl,
			;	    char *TransLen, unsigned from, unsigned to,
			;	    unsigned MDist)
MACRO	PACKBLOCK offsin, segin, offsout, segout, offstranst, segtranst,\
		  offstransl, segtransl, from, to, mdist
	push	mdist
	push	to
	push	from
	push	segtransl
	push	offstransl
	push	segtranst
	push	offstranst
	push	segout
	push	offsout
	push	segin
	push	offsin
	call	_PackBlock
	add	sp, 22
ENDM

			;PackFile2File (int In, int Out, char far *TransTbl,
			;	char far *TransLen, unsigned MatchDist)
MACRO	PACKFILE2FILE inhandle, outhandle, offstrans, segtrans, offslen, seglen, mdist
	push	mdist
	push	seglen
	push	offslen
	push	segtrans
	push	offstrans
	push	outhandle
	push	inhandle
	call	_PackFile2File
	add	sp, 14
ENDM

			;PackOneFile (int InHandle, int OutHandle,
			;		unsigned MDist)
MACRO	PACKONEFILE inhandle, outhanle, mdist
	push	mdist
	push	outhandle
	push	inhandle
	call	_PackOneFile
	add	sp, 6
ENDM
			;CreateUnPackTbl (char *FileTbl, char *UnPackTbl)
MACRO	CREATEUNPACKTBL offsftbl, segftbl, offsuntbl, seguntbl
	push	seguntbl
	push	offsuntbl
	push	segftbl
	push	offsftbl
	call	_CreateUnPackTbl
	add	sp, 8
ENDM
			;unsigned ReadBits (char *In)
MACRO	READBITS offsin, segin
	push	segin
	push	offsin
	call	_ReadBits
	add	sp, 4
ENDM
			;unsigned ReadNBits (char far *In, unsigned len)
MACRO	READNBITS offsin, segin, len
	push	len
	push	segin
	push	offsin
	call	_ReadNBits
	add	sp, 6
ENDM
			;unsigned UnPackBlock (char *In, char *Out, char *UnPackTbl,
			;                      unsigned from, unsigned to)
MACRO	UNPACKBLOCK offsin, segin, offsout, segout, offsuntbl, seguntbl,\
		    from, to
	push	to
	push	from
	push	seguntbl
	push	offsuntbl
	push	segout
	push	offsout
	push	segin
	push	offsin
	call	_UnPackBlock
	add	sp, 16
ENDM

			; UnPackFile2File (int in, int out, long fsize,
			;	char far *TransTbl)
MACRO	UNPACKFILE2FILE in, out, fsizel, fsizeh, offstrans, segtrans
	push	segtrans
	push	offstrans
	push	fsizeh
	push	fsizel
	push	out
	push	in
	call	_UnPackFile2File
	add	sp, 12
ENDM


;----------------------------------------------------------------------

;**********************************************************************
;   long getChrFreq (int FileHand, long *ChrFreqTbl)
;---------------------------------------------------------------------
; Erstellt Hufigkeitstabelle (lscht Werte nicht!)
; liefert die Lnge der Datei zurck in ax:dx
;**********************************************************************

PROC	_getChrFreq
	ARG	@@FileHand: WORD, @@PtrTbl: DWORD
	LOCAL	@@FSize: DWORD = @@size

	push	bp			;bp sichern
	mov	bp, sp			;sp = bp
	sub	sp, @@size              ;Locale vars.

	push	si      		;na was wohl?
	push	di

	mov	[WORD @@FSize], 0	;FSize = 0
	mov	[WORD @@FSize + 2], 0   ;  <-+

@@ReadBlock:
	mov	si, OFFSET InBuffer	;si = &InBuffer

			;int read (int handle, char *buf, unsigned len);
	READ [@@FileHand], si, InBufSeg, 65534

	or	ax, ax			;if (EOF)
	jz	@@End			;  goto End

	add	[WORD @@FSize], ax	;FSize += ax
	adc	[WORD @@FSize+2], 0	;  <-+

	cld				;Richtung: --->
	mov     cx, ax			;Counter = Anz. gelesene Zeichen

	les	bx, [@@PtrTbl]		;es:bx zeigt auf PtrTbl
	push	ds			;ds sichern
	mov	ax, InBufSeg		;ds = SEG InBuffer
	mov	ds, ax			;  <-+

@@Loop:                                 ;for (cx = Anz. gelesene Zeich;...) {
	lodsb				;  ax = *InBuffer++;
	xor	ah, ah			;    <-+
	shl	ax, 2			;  ax *= 2;
	mov	di, ax			;  di = ax;
	add	[WORD es:bx+di], 1	;  ChrFreqTbl[di]++;
	adc	[WORD es:bx+di+2],0	;    <-+
	loop	@@Loop			;}

	pop	ds			;ds zurck
	jmp	@@ReadBlock		;goto ReadBlock

@@End:
	mov	ax, [WORD @@FSize]	;ax:dx = @@FSize
	mov	dx, [WORD @@FSize+2]	; <-+

	pop	di			;Regs zurck
	pop	si
	mov	sp, bp			;Stack zurck
	pop	bp
	ret                             ;ENDE (endlich)
ENDP

;**********************************************************************
;  getOrdChrTbl (long *ChrFreq, char *OrdChrTbl)
;---------------------------------------------------------------------
; Erstellt Tabelle fr Hufigkeit der Zeichen:
;  OrdChrTbl[0] = hufigstes Zeichen
;  OrcChrTbl[255] = seltenstes Zeichen
;**********************************************************************

PROC	_getOrdChrTbl
	ARG	@@PtrFreq: DWORD, @@PtrTbl: DWORD
	LOCAL	@@SIMax:WORD = @@Size

	push	bp			;Stack einrichten
	mov	bp, sp
	sub	sp, @@Size

	push	ds			;Regs sichern
	push	si
	push	di

	;--- Tabelle auf 0 - 256 init. ---
	les	di, [@@PtrTbl]		;es:di zeigt auf OrdChrTbl
	mov	cx,	256		;Counter = 256
	xor	al,	al		;Wert = 0
	cld				;Richtung: ---->

@@InitLp:                               ;for (cx = 256...) {
	stosb				;  [es:di++] = al;
	inc	al			;  al++;
	loop	@@InitLp		;}

	les     bx, [@@PtrFreq]		;es:bx zeigt auf ChrFreq
	lds	si, [@@PtrTbl]		;ds:si zeigt auf OrdChrTbl


	mov	cx, 255			;Counter = 255 (letztes Element egal)

@@TblLoop:      			;for (cx = 255....) {
	xor	ax, ax			;  ax = 0; (high-Teil)
	xor	dx, dx			;  dx = 0; (low-Teil)
	push	si			;  si sichern
	inc	si			;  si++;
	push	cx			;  cx sichern

	;--- suche nach grtem Wert, in ChrFreq[ChrOrdTbl++] ---
@@FreqLoop:				;  for (cx ....) {
					;    di = (char)[si] * 4
	push	ax			;     ax sichern
	mov	al, [si]		;     al = *PtrTbl;
	xor	ah, ah			;     ah = 0
	shl	ax, 2			;     ax *= 4;
	mov	di, ax			;     di = ax
	pop	ax			;     ax zurck

	cmp	[es:bx+di+2], ax	;    if ((high)PtrFreq[di] < ax)
	jb	@@NotGreater		;      goto NotGreater;
	ja	@@IsGreater		;    if ((high)PtrFreq[di] > ax) goto IsGreater
	cmp	[es:bx+di], dx		;    if ((low)PtrFreq[di] < dx)
	jb	@@NotGreater		;      goto NotGreater;

@@IsGreater:                            ;    if (PtrFreq[di] > ax:dx) {
	mov	ax, [es:bx+di+2]	;      ax = (high)PtrFreq[di];
	mov	dx, [es:bx+di] 		;      dx = (low)PtrFreq[di];
	mov	[@@SIMax], si		;      SIMax = si;
@@NotGreater:                           ;    }
	inc	si			;    PtrTbl++;
	loop	@@FreqLoop		;  }

	;--- Wenn grter Wert grer dieser Wert -> tauschen ---
	pop	cx			;  Counter zurck
	pop	si                      ;  si <PtrTbl>zurck

					;  di = (char)[si] * 4
	push	ax			;   ax sichern
	mov	al, [si]		;   al = *PtrTbl;
	xor	ah, ah			;   ah = 0;
	shl	ax, 2			;   ax *= 2;
	mov	di, ax			;   di = ax;
	pop	ax			;   ax zurck

	cmp	[es:bx+di+2], ax	;  if ((high)PtrFreq[di] > ax)
	ja	@@NoChange		;    goto NoChange;
	jb	@@DoChange		;  if ((high)PtrFreq[di] < ax) goto DoChange;
	cmp	[es:bx+di], dx		;  if ((low)PtrFreq[di] > dx)
	ja	@@NoChange		;    goto NoChange;
@@DoChange:                             ;   {
	mov	di, [@@SIMax]		;    di = SIMax;
	mov	al, [di]		;    [si] <===> [di]
	xchg	[si], al		;      <-+
	mov	[di], al		;      <-+
@@NoChange:                             ;   }
	inc	si			;  si++;
	loop    @@TblLoop		;}

	pop	di			;Regs zurck
	pop	si
	pop	ds
	mov	sp, bp			;Stackvar. zurck
	pop	bp
	ret
ENDP

;***********************************************************************
;  CreateTransTbl (char *ChrOrdTbl, unsigned *TransTbl, char *TransLen,
;			char *FileTbl)
;----------------------------------------------------------------------
; erstellt bersetungstabelle im Huffman-Vormat:
; *ChrOrdTbl[256] - Tabelle der Buchstaben, nach Hufigkeit geordnet
; *TransTbl[256]  - Huffman - Codes der Zeichen
; *TransLen[256]  - Bitlnge der Huffman-Zeichen
; *FileTbl[128]   - bersetzungsdaten fr Datei
;***********************************************************************

PROC	_CreateTransTbl
	ARG	@@PtrOrd: DWORD, @@PtrTbl: DWORD,\
		@@PtrLen: DWORD, @@PtrFTbl: DWORD
	LOCAL   @@I: WORD = @@size

	push	bp			;Stack vorbereiten
	mov	bp, sp
	sub	sp, @@size

	push	ds			;Regs sichern
	push	si
	push	di

	;------ FileTbl erstellen ------
					;125 kurze Codes:
	lds	si, [@@PtrOrd]		; ds:si zeigt auf ChrOrdTbl
	les	di, [@@PtrFTbl]		; es:di zeigt auf FileTbl
	mov	cx, 125 		; Counter = 125 = <14Bit - Codes
	cld				; Richtung: ----->
	rep	movsb			; kopiere 125Bytes es:di = ds:si

	add	si, 128			;3 kurze Codes:
	mov	cx, 3			; Counter = 3
	rep	movsb			; kopiere 125Bytes es:di = ds:si

	; ---- bersetungstabellen TransTbl, TransLen erstellen ----

					;Lngen-Tabelle lschen
	les	di, [@@PtrLen]		; es:di zeigt auf TransLen
	xor	ax, ax			; ax = 0
	mov	cx, 128			; Counter = 128 (Words = 256Bytes)
	rep	stosw		 	; 256Bytes in [es:di] lschen

	les	di, [@@PtrTbl]		;es:di zeigt auf TrnsTbl
	lds	si, [@@PtrLen]		;ds:si zeigt uf PtrLen

					;125 kurze Codes:
	mov	cx, 125			; Counter = 125
	mov	bl, 2			; Mgl. = 2
	mov	bh, 1			; Zhler Mgl. = 1 (da ESC reserviert)
	mov	dl, 2			; Bitnum = 2
	mov	[@@I], 0		; I = 0
	call	@@TransLoop		; Erstelle 125 Bits bersetung

					;3 lange Codes
	mov	cx, 3			; Counter = 3
	mov	bl, 255			; Mgl. = 256
	mov	bh, 0			; Zhler Mgl. = 0
	mov	dl, 16			; Bitnum = 16
	mov	[@@I], 253		; I = 253
	call	@@TransLoop		; Erstelle 3 Bits bersetung

					;14Bit-Codes
	mov	cx, 256			; Counter = 256
	mov	dl, 14			; Bitnum = 14
	xor	bx, bx			; Huffnum = 0
	mov	[@@I], 0		; @@I = 0 (index)

@@T14Loop:                              ; for (cx = 256...) {
	push	bx                      ;                bh sichern
	mov	bx, [@@I]               ;                bx laden
	test	[BYTE ds:si+bx], 0FFh	;   if (TransLen[bx] = 0) (unInit.)
	pop	bx			;                bh zurck
	jnz	@@No14Cd		;   {

	xor	ax, ax
	call	@@TransBit		;     ax = Huffman-Code(bh)
	push	bx			;              bh sichern
	mov	bx, [@@I]		;              bx laden
	mov	[BYTE ds:si+bx], 14	;     TransLen[bx] = 14
	shl	bx, 1			;              bx *= 2
	mov	[es:di+bx], ax		;     TransTbl[bx] = ax
	pop	bx			;              bh zurck
	inc	bh			;     bh = Hufnum++
					;   }
@@No14Cd:
	inc	[@@I]			;   I++;
	loop	@@T14Loop		; }

	pop	di			;Regs zurck
	pop     si
	pop	ds
	mov	sp, bp
	pop	bp
	ret				;Ende Fkt.
	;******************************************

	;--- TransBit: ---
	; bh = Nummer d. Codes --- ax = Huffman-Code
@@TransBit:
	mov     dh, 1			;    dh = Lesemaske = 1
	push	si			;    si sichern
	mov	si, 1			;    si = Schreibmaske = 1
	push	cx			;    cx sichern
	mov	cl, dl			;    cx = Bitnum/2
	xor	ch, ch			;      <-+
	shr	cx, 1			;      <-+

@@TBitLoop:				;    for (cx = Bitnum/2...)  {
	test	bh, dh			;      if (Bit gesetzt)
	jz      @@TBitclr		;      {
	or	ax, si			;        Bit setzen;
@@TBitclr:				;      }
	shl	dh, 1			;      Lesemaske <<= 1;
	shl	si, 1			;      Schreibmaske <<= 1;
	or	ax, si			;      weiter = 1 = Ja
	rol	si, 1			;      Schreibmaske <<= 1; nchstes Bit
	loop 	@@TBitLoop		;    }
	pop	cx                      ;    cx zurck

	ror	si, 1			;    Schreibmaske >>= 1; (auf Ende)
	xor	ax, si			;    Endbit lschen;
	pop	si			;    si zurck
	ret				;    zurck

	;--- TransLoop: ---
	; cx = Anz.geschriebene Bytes, bl = Mgl. bh = IMgl., dl = BitAnz.
	; I = Nummer des Zeichens in Hufigkeitstabelle
@@TransLoop:				; for (cx = 125....)  {
	xor	ax, ax			;   Code = 0

	call	@@TransBit		;   ax = Huffman-Code(bh)

				;ax schreiben an TransTbl[OrdChr[I]]
	push	bx                      ;    ds, si sichern
	push	ds
	push	si
	lds	si, [@@PtrOrd]		;    ds:si zeigen auf ChrOrdTbl
	add	si, [@@I]		;    ds:si zeigt auf Element
	mov     bl, [ds:si]		;    bx = OrdChrTbl[I];
	xor	bh, bh			;      <-+
	pop	si      		;    si, ds zurck
	pop	ds

	test	dl, 16			;    if (Bitnum = 16)
	jz	@@BitNl16		;    {
	mov     [BYTE ds:si+bx], 15	;      *PtrLen[bx] = 15
	jmp	@@BitNe16		;    }else
@@BitNl16:
	mov     [ds:si+bx], dl		;      *PtrLen[bx] = Bitnum
@@BitNe16:
	shl	bx, 1			;    bx *= 2 (DatenfeldIndex Words)
	mov	[es:di+bx], ax		;    *PtrTrans[bx] = Huffman
	pop	bx			;    bx zurck

	inc	[@@I]			;    I++;
	inc	bh			;    MglZhler++;
	cmp	bh, bl			;    if (MglZhler = Mgl)
	jne	@@NoEndPos		;    {
	add	dl, 2			;      Bitnum += 2;
	shl	bl, 1			;      Mgl *= 2;
	xor	bh, bh			;      MglZhler = 0;
@@NoEndPos:                             ;    }
	loop    @@TransLoop		;  }
	ret				;  ende Schleife
ENDP

;**********************************************************************
;  WriteBits (char *Out, unsigned Value, unsigned Length)
;---------------------------------------------------------------------
;  Schreibt das Huffman-Zeichen Value mit der Lnge Length nach
;  OutBuffer. Aktuelle Position nach *Out: OutPos, OutBit
; verndert ax, bx, cx, dx, es
;**********************************************************************
PROC	_WriteBits
	ARG	@@Out: DWORD, @@Value: WORD, @@Length: WORD

	push	bp			;Stack einrichten
	mov	bp, sp
	push	di			;Regs sichern

	les	bx, [@@Out]		;es:bx zeigen auf OutBuffer
	mov	di, [OutPos]		;di = Index

	mov	ax, [@@Value]		;ax = Wert
	mov	cl, [OutBit]		;cl = Bit Position in OutBuffer
	mov	dx, ax			;dx = ax (gesichert)

	shl	ax, cl			;ax <<= Bitnum
	or	[es:bx+di], ax		;nach OutBuffer
	mov	ch, cl			;ch = cl (fr spter)
	add	cl, [BYTE @@Length]	;cl += Length
	test	cl, 16			;if (OutBit >= 16)
	jz	@@End			;{
	add	di, 2			;  di += 2;
	and	cl, 15			;  cl -= 16
	sub	ch, 16			;  ch -= 16
	neg	ch			;  ch = -ch
	xchg	ch, cl			;  ch <==> cl
	shr	dx, cl			;  bx = Value >> cl
	xchg	ch, cl			;  ch <==>
	mov	[es:bx+di], dx		;  nach OutBuffer
	mov	[OutPos], di		;  OutPos = di (OutPos += 2)
					;}
@@End:
	mov	[OutBit], cl		;  OutBit = cl

	pop	di			;Regs zurck
	pop	bp
	ret				;Ende
ENDP

;**********************************************************************
;* getHuffStrLen (char far *str, unsigend length, char far *TransLen)
;*---------------------------------------------------------------------
;* liefert die Bitlnge des Huffmankomprimierten Strings str, mit Lnge
;* len
;* benutzt: ax,bx,cx,dx
;**********************************************************************
;  ----------- Parameter werden automatisch gelscht -------------

PROC	_getHuffStrLen
	ARG	@@Ptr: DWORD, @@Length: WORD, @@LenPtr: DWORD

	push	bp			;Stack vorbereiten
	mov	bp, sp
	push	ds			;Regs sichern
	push	si
	push	di

	lds	si, [@@Ptr]		;ds:si zeigen auf str
	les	bx, [@@LenPtr]		;es:bx auf TransLen
	mov	cx, [@@Length]		;Counter = Length
	xor	dx, dx			;Summe = 0
	xor	ah, ah			;ah lschen
	cld				;Richtung: ----->

@@AddLoop:				;for (Counter = Length...) {
	lodsb                           ;  di = Zeichen
	mov	di, ax
	add	dl, [es:bx+di]		;  dx += TransLen[Zeichen]
	adc	dh, 0			;     <-+
	loop	@@AddLoop               ;}

	mov	ax, dx			;return dx

	pop	di			;Regs zurck
	pop	si
	pop	ds
	pop	bp
	ret
ENDP

;***********************************************************************
;*  PackBlock (char *In, char *Out, unsigned *TransTbl,                *
;*		    char *TransLen, unsigned from, unsigned to,	       *
;*		    unsigned MDist)		  		       *
;*---------------------------------------------------------------------*
;* Packt den Block Out, nach In, von Pos. from bis to, beginnt Ausgabe *
;* bei Bit start. 						       *
;* LZ2 - Match - Tags haben die max. entfernung MDist (oder            *
;* Blockanfang							       *
;***********************************************************************

PROC	_PackBlock
	ARG	@@PtrIn: DWORD, @@PtrOut: DWORD,\
		@@PtrTrans: DWORD, @@PtrLen: DWORD,\
		@@from: WORD, @@to: WORD, @@MDist: WORD
	LOCAL	@@Opt1: WORD, @@Opt2: WORD, @@Opt3: WORD, @@Opt4: WORD,\
		@@LZ1Pos: WORD , @@LZ1Len: WORD,\
		@@LZ2Pos: WORD , @@LZ2Len: WORD  = @@size

	push	bp      		;Stack vorbereiten
	mov	bp, sp
	sub	sp, @@size
	push	di			;Regs sichern
	push	si

	les	bx, [@@PtrIn]		;es:bx zeigen auf In
	mov	si, [@@from]		;si = from

@@Loop:					;while (si < @@to)
	cmp	si, [@@to]              ;        <-+
	jae	@@LoopEnd		;{

	call	@@ChkHuff		;  ChkHuff () --> Opt1
	call	@@ChkLZ1		;  ChkLZ1 () --> Opt2
	call	@@ChkLZ2		;  ChkLZ2 () --> Opt3
	call	@@ChkRLE		;  ChkRLE () --> Opt4

					;  beste Opt? --> cx
	mov	cx, 1                   ;   cx = 1
	mov	ax, [@@Opt1]            ;   ax = Opt1
	cmp	[@@Opt2], ax 		;   if (Opt2 < ax)
	jl	@@Opt2Worse		;     goto Opt2Worse
	mov	ax, [@@Opt2]            ;   ax = Opt2
	mov	cx, 2                   ;   cx = 2
@@Opt2Worse:
	cmp	[@@Opt3], ax		;   if (Opt3 < ax)
	jl	@@Opt3Worse		;     goto Opt3Worse
	mov	ax, [@@Opt3]		;   ax = Opt3
	mov	cx, 3			;   cx = 2
@@Opt3Worse:
	cmp	[@@Opt4], ax		;   if (Opt4 < ax)
	jl	@@Opt4Worse		;     goto Opt4Worse
	mov	ax, [@@Opt4]		;   ax = Opt4
	mov	cx, 4			;   cx = 4
@@Opt4Worse:
					;   Fhre beste Komprimierung aus
	cmp	cx, 1			;    if cx != 1
	jne	@@NotHuff		;      goto NotHuff
	call	@@PkHuff		;    PkHuff ()
	jmp	@@PkDone		;      goto PkDone
@@NotHuff:				;	.
	cmp	cx, 2                   ;       .
	jne	@@NotLZ1                ;       .
	call	@@PkLZ1
	jmp	@@PkDone
@@NotLZ1:
	cmp	cx, 3
	jne	@@NotLZ2
	call	@@PkLZ2
	jmp	@@PkDone
@@NotLZ2:
	call	@@PkRLE
@@PkDone:

	jmp	@@Loop			;} Ende Kompimierungsschleife

@@LoopEnd:

	pop	si			;Regs zurck
	pop	di
	mov	sp, bp			;Stack zurck
	pop	bp
	ret

;*********************** Huffman **********************
	;-------- Optimierung? ----------
@@ChkHuff:
	mov	[@@Opt1], 0		;Opt1 = 0
	ret

	;--------- Packen ----------
@@PkHuff:
	push	es                     	;Regs sichern
	push	bx
	mov	al, [es:bx+si]		;ax = Zeichen
	xor	ah, ah
	les	di, [@@PtrLen]		;es:di zeigt auf TransLen[Zeichen]
	add	di, ax
	mov	dl, [es:di]		;dx = TransLen[Zeichen]
	xor	dh, dh
					;es:di zeigt auf TransTbl[Zeichen]
	les	di, [@@PtrTrans]
	shl	ax, 1
	add	di, ax
		; --- WriteBits (&Out, TransTbl[HuffChr], HuffLen)
	WRITEBITS <[WORD @@PtrOut]>, <[Word @@PtrOut+2]> <[WORD es:di]>, dx
	inc	si			;si++ - nchstes Byte

	pop	bx			;Regs Zurck
	pop	es
	ret				;ENDE
;********************** LZ1 ************************
	;------ Optimierung ? -------
@@ChkLZ1:
	push	ds

	mov	[@@Opt2], -1000
	test	[@@MDist], 0FFFFh	;if (MDist == 0)
	jnz	@@DoLZ1			;  goto NoLZ1
	jmp	@@NoLZ1			;   <-+ (Relative jump out of range)
@@DoLZ1:
	mov	ax, [@@to]		;if (si > to-17)
	sub	ax, 17                  ;  <-+
	cmp	si, ax                  ;  <-+
	ja	@@NoLZ1 	        ;  goto NoLZ1
	cmp	si, 17                  ;if (si < 17)
	jb	@@NoLZ1			;  goto NoLZ1

	cld				;  Richtung: --------->

		;--- Vorbereitung zum Suchen ---
	mov	[@@LZ1Len], -1000
	mov	al, [es:bx+si]		;  ax = akt. Zeichen
	cmp	si, 143			;  if (si < 143)
	jae	@@LZ1OK			;  {
	xor	di, di			;    di = 0;
	mov	cx, si			;    cx = Pos - 16
	sub	cx, 16
	jmp	@@SearchLZ1		;  }else
@@LZ1OK:                                ;  {
	mov	cx, 127			;    cx = 127
	mov	di, si			;    di = si - 143
	sub	di, 143

		;--- Suchen -------
@@SearchLZ1:
	repne	scasb			;  suche nach akt. Zeichen
	jne	@@EndLZ1		;  keins gefunden ? zu EndLZ1

					;  Suche nach Lnge d. bereinstimmung
	mov	dx, cx			;  dx = cx (gesichert fr spter)
	push	ax
	push	di
	push	si
	inc	si			;  si erhhen, auf nchstes Zeichen

	mov	cx, 17			;  cx = 17
	push	es			;  es:di auf InBuffer[found+1]
	pop	ds                      ;  ds:si auf InBuffer[Pos+1]
	repe	cmpsb                   ;  vergleiche InBuffer[InPos+1] mit InBuffer[MPos+1]
	cmp	cx, 16			;  Wenn cx = 16 -> nur 1Byte - weiter
	je	@@ContLZ1
	sub	cx, 15			;  cx = 15-cx (0: 2Bytes, 15: 17Bytes)
	neg	cx

	cmp	cx, [@@LZ1Len]		;  if (cx > LZ1Len)
	jl	@@ContLZ1		;  {
	mov	[@@LZ1Len], cx		;    LZ1Len = cx
	mov	[@@LZ1Pos], dx		;    LZ1Pos = dx
@@ContLZ1: 	                        ;  }
	pop	si			;
	pop	di
	pop	ax
	mov	cx, dx
	jcxz	@@EndLZ1
	jmp     @@SearchLZ1		;suche weiter

@@EndLZ1:
	cmp	[@@LZ1Len], -1000       ;if (LZ1Len == -1000)
	je	@@NoLZ1                 ;  goto NoLZ1

	mov	ax, [@@LZ1Len]          ;ax = LZ1Len + 2
	add	al, 2
	push	si                      ;si += bx
	add	si, bx
	push	bx                      ;bx, si, es gesichert
	push    es
	GETHUFFSTRLEN si, es, ax, <[WORD @@PtrLen]>, <[WORD @@PtrLen+2]>
	pop	es                      ;bx, es zurck
	pop	bx
	pop	si

	sub	ax, 14			;Opt2 = ax - 14
	mov	[@@Opt2], ax
@@NoLZ1:
	pop	ds
	ret

	;-------- Packen -----------
@@PkLZ1:
	push	es
	push	bx
					;schreibe ESC-Seq.
	WRITEBITS <[WORD @@PtrOut]>, <[WORD @@PtrOut + 2]>, 0, 2
			;schreibe Position (beginnende 0 ist eingeschlossen)
	WRITEBITS <[WORD @@PtrOut]>, <[WORD @@PtrOut + 2]>, [@@LZ1Pos], 8
	WRITEBITS <[WORD @@PtrOut]>, <[WORD @@PtrOut + 2]>, [@@LZ1Len], 4
	pop	bx
	pop	es
	add	si, [@@LZ1Len]
	add	si, 2
	ret
;********************** LZ2 ************************
	;------ Optimierung ? -------
@@ChkLZ2:
	push	ds

	mov	[@@Opt3], -1000
	cmp	[@@MDist], 128		;if (MDist <= 128)
	jb	@@JNoLZ2		;  goto NoLZ2
	mov	ax, [@@to]		;if (si > to-65)
	sub	ax, 65                  ;  <-+
	cmp	si, ax                  ;  <-+
	ja	@@JNoLZ2 	        ;  goto NoLZ2
	cmp	si, 65                  ;if (si < 65)
	jb	@@JNoLZ2		;  goto NoLZ2
	jmp	@@DoLZ2			;    (wegen Relativ jump out of range)

@@JNoLZ2:
	jmp	@@NoLZ2

@@DoLZ2:
	cld				;  Richtung: --------->

		;--- Vorbereitung zum Suchen ---
	mov	[@@LZ2Len], -1000
	mov	al, [es:bx+si]		;  ax = akt. Zeichen
	cmp	si, [@@MDist]		;  if (si < MDist)
	jae	@@LZ2OK			;  {
	xor	di, di			;    di = 0;
	mov	cx, si			;    cx = Pos - 64
	sub	cx, 64
	jmp	@@SearchLZ2		;  }else
@@LZ2OK:                                ;  {
	mov	cx, [@@MDist]		;    cx = 32767
	mov	di, si			;    di = si - MDist - 65
	sub	di, [@@MDist]
	sub	di, 65

		;--- Suchen -------
@@SearchLZ2:
	repne	scasb			;  suche nach akt. Zeichen
	jne	@@EndLZ2		;  keins gefunden ? zu EndLZ2

					;  Suche nach Lnge d. bereinstimmung
	mov	dx, cx			;  dx = cx (gesichert fr spter)
	push	ax
	push	di
	push	si
	inc	si			;  si erhhen, auf nchstes Zeichen

	mov	cx, 65			;  cx = 17
	push	es			;  es:di auf InBuffer[found+1]
	pop	ds                      ;  ds:si auf InBuffer[Pos+1]
	repe	cmpsb                   ;  vergleiche InBuffer[InPos+1] mit InBuffer[MPos+1]
	cmp	cx, 64			;  Wenn cx = 64 -> nur 1Byte - weiter
	je	@@ContLZ2
	sub	cx, 63			;  cx = 63-cx (0: 2Bytes, 63: 65Bytes)
	neg	cx

	cmp	cx, [@@LZ2Len]		;  if (cx > LZ2Len)
	jl	@@ContLZ2		;  {
	mov	[@@LZ2Len], cx		;    LZ2Len = cx
	mov	[@@LZ2Pos], dx		;    LZ2Pos = dx
@@ContLZ2:                              ;  }
	pop	si			;
	pop	di
	pop	ax
	mov	cx, dx
	jcxz	@@EndLZ2
	jmp     @@SearchLZ2		;suche weiter

@@EndLZ2:
	cmp	[@@LZ2Len], -1000       ;if (LZ1Len == -1000)
	je	@@NoLZ2                 ;  goto NoLZ1

	mov	ax, [@@LZ2Len]          ;ax = LZ1Len + 2
	add	al, 2
	push	si                      ;si += bx
	add	si, bx
	push	bx                      ;bx, si, es gesichert
	push    es
	GETHUFFSTRLEN si, es, ax, <[WORD @@PtrLen]>, <[WORD @@PtrLen+2]>
	pop	es                      ;bx, es zurck
	pop	bx
	pop	si

	sub	ax, 24			;Opt3 = ax - 24
	mov	[@@Opt3], ax
@@NoLZ2:
	pop	ds
	ret

	;-------- Packen -----------
@@PkLZ2:
	push	es
	push	bx
					;schreibe ESC-Seq.
	WRITEBITS <[WORD @@PtrOut]>, <[WORD @@PtrOut + 2]>, 0, 2
			;schreibe Position (beginnende 0 ist eingeschlossen)
	WRITEBITS <[WORD @@PtrOut]>, <[WORD @@PtrOut + 2]>, [@@LZ1Pos], 16
	WRITEBITS <[WORD @@PtrOut]>, <[WORD @@PtrOut + 2]>, [@@LZ1Len], 6
	pop	bx
	pop	es
	add	si, [@@LZ2Len]
	add	si, 2
	ret

;********************** RLE ************************
	;------ Optimierung ? -------
@@ChkRLE:
	mov	[@@Opt4], -1000
	ret
	;-------- Packen -----------
@@PkRLE:
	ret
ENDP

;**********************************************************************
; PackFile2File (int In, int Out, char far *TransTbl,
;		char far *TransLen, unsigned MatchDist)
;---------------------------------------------------------------------
; Packt In nach Out, wobei angenommen wird, da TransTbl und TransLen
; bereits initialisiert sind.
;**********************************************************************

PROC _PackFile2File
	ARG	@@InHandle: WORD, @@OutHandle: WORD, @@PtrTrans: DWORD, @@PtrLen: DWORD, @@MDist: WORD
	LOCAL   @@from: Word, @@to: Word = @@size

	push	bp			;Stack vorbereiten
	mov	bp, sp
	sub	sp, @@size

;---------------------- Packen -----------------------
   ;----- Vorbereitung fr ersten Block ------
	push	di			;Regs sichern
	push	si

	READ [@@InHandle], <OFFSET InBuffer>, <SEG InBuffer>, 33534	;(int) read(handle, &buf, (unsigned)len);
	mov	[@@to], ax		;To = ax = Anz. gelesene Bytes
	mov	[@@from], 0		;from = 0

	mov	dx, SEG OutBuffer       ;OutBuffer[0] = 0
	mov	es, dx
	mov	[WORD es:OutBuffer], 0

	mov	[OutPos], 0		;OutPos = 0
	mov	[OutBit], 0		;OutBit = 0

  ;---------------- Packschleife --------------
@@PackLoop:      			;do {
		;PackBlock (&In, &Out, &TransTbl, &TransLen, from, to, MDist)
	PACKBLOCK <OFFSET InBuffer>, <SEG InBuffer>, <OFFSET OutBuffer>, <SEG OutBuffer>, <[WORD @@PtrTrans]>, <[WORD @@PtrTrans+2]>, <[WORD @@PtrLen]>, <[WORD @@PtrLen+2]>, [@@from], [@@to], [@@MDist]
			;write (Handle, &Buf, len)
	WRITE	[@@OutHandle], <OFFSET OutBuffer>, <SEG OutBuffer>, [OutPos]

;---------- Vorbereiten fr nchstes Packen ------------

		;--- Letztes, unfertiges Huffman - Zeichen zum Anfang
	mov	ax, SEG OutBuffer	;  es:bx zeigen auf OutBuffer
	mov	es, ax
	mov	bx, OFFSET OutBuffer
	mov	di, [OutPos]            ;  es:bx+di zeigen auf OutBuffer[OutPos]
	mov	ax, [es:bx+di]		;  OutBuffer[0] = OutBuffer[OutPos]
	mov	[es:bx], ax
	mov	[OutPos], 0

		;--- InBuffer[to - 32000] nach InBuffer[0] kopieren
	cmp	[@@to], 32001		;If (to < 32001) goto PackEnd
	jbe	@@PackEnd

	push	ds
	mov	ax, SEG InBuffer	;  ex:di zeigen auf InBuffer[0]
	mov	es, ax			;  ds:si zeigen auf InBuffer[to-32000]
	mov	ds, ax                  ;   (deshalb to < 32000 ausgefiltert)
	mov	di, OFFSET InBuffer
	mov	si, di   		;  si = OFFSET InBuffer+to-32000
	add	si, [@@to]
	sub	si, 32000
	mov	cx, 32000/2		;  Counter = 32000/2 (da Words)
	rep	movsw	;Schreibe 32000 Bytes von
			;InBuffer[33000] nach InBuffer[0]
	pop	ds

	READ [@@InHandle], <OFFSET InBuffer+32000>, <SEG InBuffer>, 33534
	or	ax, ax			;  if (ax == 0)
	jz	@@PackEnd		;    goto PackEnd

	add	ax, 32000		;  Anz. gelesene Bytes+32000 nach to
	mov	[@@to], ax		;  To = ax = Anz. gelesene Bytes
	mov	[@@from], 32000		;  from = 0
	jmp	@@PackLoop		;}
;------------ Ende PackSchleife -------------

@@PackEnd:
			;unvollstndiges Huffmanzeichen schreiben
	WRITE [@@OutHandle], <OFFSET OutBuffer>, <SEG OutBuffer>, 2

	pop	si			;Regs zurck
	pop	di
	mov	sp, bp			;Stack zurck
	pop	bp
	ret
ENDP

;**********************************************************************
;*  PackOneFile (int InHandle, int OutHandle, unsigned MDist)         *
;*--------------------------------------------------------------------*
;* Packt die Datei In, nach Out, Matchtags verweisen maximal um MDist *
;* zurck                                                             *
;**********************************************************************
PROC	_PackOneFile
	ARG	@@InHandle: WORD, @@OutHandle: WORD, @@MDist: WORD

	push	bp                      ;Stack vorbereiten
	mov	bp, sp

;------------------ Vorbereitung --------------------
			; ------ ChrFreq - Tabelle auf 0 init. ----
	push	ds
	pop	es
	mov	di, OFFSET ChrFreq
	mov	cx, 512			;512 Words = 256 Doublewords
	xor	ax, ax			;ax = 0 -> auf 0 init.
	rep	stosw			;Schreibe 256 doublewords 0 nach
					;ChrFreq

	GETCHRFREQ [@@InHandle], <OFFSET ChrFreq>, <SEG ChrFreq>
					;getChrFreq (int Handle, long &ChrFrequ)

	mov	[WORD FileTbl], ax  	;FileTbl[0] = FSize
	mov	[WORD FileTbl+2], dx

	LSEEK  [@@InHandle], 0, 0, 0
					;lseek (Handle, (long) Offset, fromwhere)
	GETORDCHRTBL <OFFSET ChrFreq>, <SEG ChrFreq>, <OFFSET OrdChrTbl> <SEG OrdChrTbl>	;getOrdChrTbl (long &ChrFreq, char &OrdChrTbl)

	CREATETRANSTBL <OFFSET OrdChrTbl>, <SEG OrdChrTbl>, <OFFSET TransTbl>, <SEG TransTbl>, <OFFSET TransLen>, <SEG TransLen>, <OFFSET FileTbl + 4>, <SEG FileTbl>

	WRITE [@@OutHandle], <OFFSET FileTbl>, <SEG FileTbl>, 132	;write (Handle, &Buf, len)

;------------------ Packen -------------------------
	PACKFILE2FILE [@@InHandle], [@@OutHandle], <OFFSET TransTbl>, <SEG TransTbl>, <OFFSET TransLen>, <SEG TransLen>, [@@MDist]

	mov	sp, bp			;Stack zurck
	pop	bp
	ret
ENDP

;**************************************************************************
;**************************************************************************
;                           Entpacken
;**************************************************************************
;**************************************************************************


;**********************************************************************
;  CreateUnPackTbl (char *FileTbl, char *UnPackTbl)
;--------------------------------------------------------------------
; Erstellt mit Hilfe der in der Datei enthaltenen bersetungstabelle
; FileTbl die Rckbersetungstabelle UnPackTbl
;**********************************************************************
PROC	_CreateUnPackTbl
	ARG	 @@PtrFTbl: DWORD, @@PtrUnTbl: DWORD
	push	bp			;Stack vorbereiten
	mov	bp, sp
	push	ds                      ;Regs sichern
	push	di
	push	si

	push	ds                      ;KnownChr auf 0 init.
	pop	es
	mov	di, OFFSET KnownChr
	xor	ax, ax
	mov	cx, 128
	cld
	rep	stosw			;schreibe 128 Words nach KnownChr

	les	bx, [@@PtrUnTbl]
	lds	si, [@@PtrFTbl]         ;kopiere 125 Hufigkeitszeichen
	mov	cx, 125                 ;for (cx = 125....) {
@@Loop125:
	lodsb				;  di = Zeichen = FileTbl[I]
	xor	ah, ah
	mov	di, ax
	push	ds
	mov	dx, @data		;  Datensegment einstellen
	mov	ds, dx
	mov	[BYTE KnownChr+di], 0FFh;  KnownChr[Zeichen] = 1
	pop	ds
	mov	[es:bx], al		;  PtrUnTbl[I] = Zeichen
	inc	bx      		;  I++
	loop	@@Loop125               ;}

	add	bx, 128			;bx += 127 (fr Endzeichen)
	mov	cx, 3	                ;for (cx = 3....) {
@@Loop3:
	lodsb				;  di = Zeichen = FileTbl[I]
	xor	ah, ah
	mov	di, ax
	push	ds			;  Datensegment nach ds
	mov	dx, @data
	mov	ds, dx
	mov	[BYTE KnownChr+di], 0FFh;  KnownChr[Zeichen] = 1
	pop	ds
	mov	[es:bx], al		;  PtrUnTbl[I] = Zeichen
	inc	bx      		;  I++
	loop	@@Loop3                 ;}
					;128 unbekannte Zeichen:

	mov	ds, [WORD @@PtrUnTbl+2] ;ds:bx auf erstes Un. Zeichen
	mov	ax, @data		;ds auf DAtensegment
	mov	es, ax
	sub	bx, 131
	mov	cx, 128			;for (cx = 128...) {
@@Loop128:
	mov	al, 0FFh		;  suche unbekanntes Zeichen:
	push	cx
	mov	cx, 256
	mov	di, OFFSET KnownChr
	repe	scasb 			;  durchsuche KnownChr nach 0
	mov	[BYTE es:di-1], 0FFh	;  Zeichen ist Bekannt!

	sub	cx, 255			;  cx = Index:
	neg	cx
	mov     [ds:bx], cl		;  PtrUnTbl[I] = Index
	inc	bx			;  I++;
	pop	cx
	loop	@@Loop128		;}

	pop     si			;Regs zurck
	pop	di
	pop	ds
	pop	bp
	ret
ENDP

;**********************************************************************
;  unsigned ReadBits (char *In)
;---------------------------------------------------------------------
; liest den Huffmancode aus In, an Position InPos, InBit und liefert
; das Ergebnis in ax
;**********************************************************************
PROC	_ReadBits
	ARG	@@PtrIn: DWORD
	push	bp			;Stack vorbereiten
	mov	bp, sp
	push	di			;Regs sichern
	push	si

	les	si, [@@PtrIn]		;es:si zeigen auf InBuffer
	add	si, [InPos]             ;es:si zeigen auf Aktuelles Byte
	mov     cl, [INBit]             ;cl = InBit
	mov	dx, 1			;dx = InMask
	shl	dx, cl
	xor	di, di			;di = Anz. gelesene Bits = 0
	mov	bl, 1			;bl = OutMask = 1
	xor	ax, ax			;ax = returnWert = 0
	mov	cx, [es:si]		;cx = Huffman - Word

@@ReadLoop:				;do  {
	test	cx, dx			;  If (Daten - Bit gesetzt)
	jz	@@BitClr		;  {
	or	al, bl			;    Bit setzen; }
@@BitClr:
	inc	di			;  BitNum++;
	cmp	di, 15			;  if Bitnum = 15
	je	@@EndLpNoEndBit		;    goto EndLpNoEndBit
	shl	bl, 1			;  Nchstes OutBit
	rol     dx, 1			;  Nchstes InBit

					;  Teste berlauf
	test	dl, 1			;  if (InMaske = 1)
	jz	@@NoDBitO		;  {
	add	si, 2			;    nchstes Word einlesen
	mov	cx, [es:si]		;      <-+
	add	[InPos], 2		;      <-+
@@NoDBitO:				;  }

	test	cx, dx			;  if (Continue - Bit gelscht)
	jz	@@EndLoop               ;    goto EndLoop
	rol	dx, 1			;  Nchstes Bit - DatenBit
	inc	di			;  BitNum++

					;  Teste berlauf
	test	dl, 1			;  if (InMaske = 1)
	jz	@@NoCBitO		;  {
	add	si, 2			;    nchstes Word einlesen
	mov	cx, [es:si]		;      <-+
	add	[InPos], 2		;      <-+
@@NoCBitO:				;  }

	jmp	@@ReadLoop		;}
@@EndLoop:
	inc	di			;BitNum++; (wenn Bitnum != 15)
@@EndLpNoEndBit:
	rol	dx, 1			;Auf nchstes Bit

					;Teste berlauf
	test	dl, 1			;  if (InMaske = 1)
	jz	@@NoEBitO		;  {
	add	si, 2			;    nchstes Word einlesen
	mov	cx, [es:si]		;      <-+
	add	[InPos], 2		;      <-+
@@NoEBitO:				;  }

	mov	dx, di			;dx = neues InBit
	add	dl, [InBit]		;  <-+
	and	dl, 15			;  <-+
	mov	[InBit], dl		;  <-+
	shl	di, 1			;di *= 2 (da Worttabelle)
	add	ax, [AddHuff+di]	;ax += AddHuff[BitNum]

	pop	si			;Regs zurck
	pop	di
	pop	bp
	ret				;Ende
ENDP

;***********************************************************************
; ReadNBits (char far *In, unsigned len)
;-----------------------------------------------------------------------
; liest len bits von *In[InPos], InBit
;***********************************************************************
PROC _ReadNBits
	ARG	@@PtrIn: DWORD, @@Len: WORD
	push	bp    			;Stack vorbereiten
	mov	bp, sp
	push	si

	mov	dx, 0FFFFh		;dx = Maske
	mov	cl, [byte @@Len]
	shl	dx, cl
	not	dx

	les	si, [@@PtrIn]		;es:si zeigen auf PtrIn[InPos]
	add	si, [InPos]
	mov	cl, [InBit]


	mov	ax, [es:si]		;es = Wert
	shr	ax, cl			;ax >>= cl

	mov	ch, cl			;ch = cl (gesichert)
	add	cl, [BYTE @@Len]	;InBit += Len
	cmp	cl, 15			;if (InBit > 15)
	jle	@@EndRead               ;{

	add	si, 2			;  InPos += 2;
	add	[InPos], 2              ;   <-+
	and	cl, 15			;  ch &= 15
	sub	ch, 16			;  cl = 16 - cl
	neg	ch
	mov	bx, [es:si]		;  bx = nchster Wert
	xchg	ch, cl
	shl	bx, cl
	or	ax, bx			;  ax &= bx (Rest)
	mov	cl, ch			;  cl = ch
					;}
@@EndRead:
	and	ax, dx			;ax &= Maske
	mov	[InBit], cl		;InBit = cl
	pop	si
	pop	bp
	ret
ENDP

;***********************************************************************
;  unsigned UnPackBlock (char *In, char *Out, char *UnPackTbl,         *
;                    unsigned from, unsigned to)                       *
;----------------------------------------------------------------------*
; Entpackt In nach Out, von from bis to (+ und max. 256), liefert      *
; die den realen to-Wert zurck                                        *
;***********************************************************************

PROC	_UnPackBlock
	ARG 	@@PtrIn: DWORD, @@PtrOut: DWORD, @@PtrTbl: DWORD,\
		@@from: WORD, @@to: WORD
	push	bp			;Stack vorbereiten
	mov	bp, sp
	push	ds			;Regs sichern
	push	di
	push	si

	les	di, [@@PtrOut]		;es:di zeigen auf Out
	lds	si, [@@PtrTbl]		;ds:si zeigen auf PtrTbl
	mov	cx, [@@from]		;cx = from
	add	di, cx			;es:di zeigen auf Out[from]

@@UnPackLoop:
	cmp     cx, [@@to]		;while (Counter <= to)
	jae	@@UnPackEnd		;{

			;----------- lese Huffman-Sequenz ------------
	push	ds                      ;  cx, ds, es sichern
	push	cx
	push	es
	mov	ax, @data		;  ds auf Datenseg.
	mov	ds, ax
	READBITS <[WORD @@PtrIn]>, <[WORD @@PtrIn+2]> ;  ReadBits (char *InBuffer)
	pop	es			;  ---- Regs zurck
	pop	cx
	pop	ds

	cmp	ax, 0FFFFh		;  if (ax == 0xFFFF)
	jne	@@NotEsc		;  {

@@LempelZiv:
	; ------------- Lempel Ziv ----------------

			;------- lese Match Tag -----------
	push	ds                      ;    Regs sichern
	push	es
	push	cx
	mov	ax, @data               ;    ds auf Datensegment
	mov	ds, ax
	READNBITS <[WORD @@PtrIn]>, <[WORD @@PtrIn+2]>, 8
	pop	cx                      ;     Regs zurck
	pop	es
	pop	ds
			; ----- LZ1 /LZ2 ? ----
	test	ax, 128                 ;    if ax & 100000000
	jnz	@@LZ2                   ;       goto LZ2

@@LZ1:
		;-------- LZ1 -----------
	mov	dx, ax			;    dx = Position
			; ---- Lnge einlesen ---
	push	ds
	push	es
	push	cx
	push	dx
	mov	ax, @data		;    ds auf Datensegment
	mov	ds, ax
	READNBITS <[WORD @@PtrIn]>, <[WORD @@PtrIn+2]>, 4
	pop	dx
	pop	cx			;    Regs zurck
	pop	es
	pop	ds

			; ---- Kopieren ----
	push	si			;    Regs sichern
	push	ds
	push	cx

	push	es                      ;    ds:si auf Out[OutPos-17-ax]
	pop	ds
	mov	si, di                  ;    si = di - 17 - Position (ax)
	sub	si, 17
	sub	si, dx

	mov	cx, ax			;    Counter = Readbits(...,4)+2
	add	cx, 2
	mov	dx, cx			;    dx = cx (fr spter)
	rep	movsb			;  ---  kopiere.

	pop	cx    		        ;    Regs zurck
	pop	ds
	pop	si
	add	cx, dx			;    cx += dx (Lnge)
	jmp	@@UnPackLoop		;    continue;}
	;-------------------------------------------------

		;-------- LZ2 -----------
@@LZ2:

	;-------------------------------------------------


	jmp	@@UnPackLoop		;    continue;}

	;--------------- Huffman ----------------
@@NotEsc:
	push	si                      ;  ds:si zeigen auf PtrTbl[Zeichen]
	add	si, ax
	movsb				;  *Out++ = PtrTbl[Zeichen]
	inc	cx			;  Counter++;
	pop	si			;  ds:si zurck auf PtrTbl[0]
	jmp     @@UnPackLoop		;}
	;-------------------------------------------------

@@UnPackEnd:
	pop	si			;Regs zurck
	pop	di
	pop	ds
	pop	bp
	mov	ax, cx			;return (Counter)
	ret
ENDP



PROC	Debug
	ARG	@@Ch: BYTE = @@Size

	push	bp
	mov	bp, sp

	push	ax
	push	es

	mov	ax, 0b800h
	mov	es, ax
	mov	al, [@@Ch]
	mov	ah, 70h
	mov	[es:0000h], ax

	pop	es
	pop	ax
	pop	bp

	ret	@@Size
ENDP

;************************************************************************
; UnPackFile2File (int in, int out, long fsize, char far *TransTbl)
;-----------------------------------------------------------------------
; entpackt in nach out, wobei vorausgesetzt wird, da fsize die Datei-
; lnge ist, und dass transtbl initialisiert ist.
;************************************************************************

PROC _UnPackFile2File
	ARG	@@InHandle: WORD, @@OutHandle: WORD, @@FSize: DWORD, @@PtrTrans: DWORD
	LOCAL	@@to: WORD, @@EndIn: WORD = @@size
	push	bp    			;Stack vorbereiten
	mov	bp, sp
	sub	sp, @@size
	push	ds			;Regs sichern
	push	di
	push	si

	READ [@@InHandle], <OFFSET InBuffer>, <SEG InBuffer>, 65534

	mov	[InPos], 0		;InPos = 0
	mov	[InBit], 0		;InBit = 0
	mov	[@@EndIn], 0		;EndIn = 0


@@NextBlock:
	mov	[InPos], 0		;InPos = 0

	;----------- Block entpacken ------------
	cmp	[WORD @@FSize+2], 0	;if (FSize < 33000)
	jg	@@Greater               ;  <-+
	cmp	[WORD @@FSize], 33000   ;  <-+
	ja	@@Greater		;{
	mov	ax, [WORD @@FSize]	;  to = FSize + from
	add	ax, 32000		;   <-+
	mov	[@@to], ax		;   <-+
	mov	[@@EndIn], 1		;  EndIn = 1;
					;}
	jmp	@@Less			;else {
@@Greater:
	mov	[@@to], 65000           ;  to = 65000
@@Less:					;}

			;UnPackBlock (&In, &Out, &UnPackTbl, from, to)
	UNPACKBLOCK <OFFSET InBuffer>, <SEG InBuffer>, <OFFSET OutBuffer>, <SEG OutBuffer>, <[WORD @@PtrTrans]>, <[WORD @@PtrTrans+2]>, 32000, [@@to]
	mov	dx, ax
	sub	dx, 32000               ;FSize -= (dx-from)
	sub	[WORD @@FSize], dx	;
	sbb	[WORD @@FSize+2], 0	;  <-+

	push	ax      		; ax sichern (zum kopieren nachher)
	WRITE [@@OutHandle], <OFFSET OutBuffer+32000>, <SEG OutBuffer>, dx
	pop	ax

	test	[@@EndIn], 1		;If (EndIn == 1)
	jnz	@@EndUnPack		;  goto EndUnPack


   ;------- nchster Block ------------
	push	ds			;ds sichern
			;OutBuffer[33000] nach OutBuffer[0] kopieren
	mov	dx, SEG OutBuffer	;ds:si auf OutBuffer[31998]
	mov	ds, dx                  ;es:di auf OutBuffer[UnPackedBytes]
	mov	es, dx
	mov	di, OFFSET OutBuffer+31998
	mov	si, OFFSET OutBuffer-2
	add	si, ax
	mov	cx, 32000/2		;Counter = 32000/2 (da Words)
	std				;Richtung: <-------
	rep	movsw			;schreibe 32000 Bytes:
			;OutBuffer[0++] = OutBuffer[32000++];


		       ;InBuffer[InPos] nach InBuffer[0] kopieren
	pop	ds			;ds zurck (zum Zugriff auf InPos)
	mov	di, OFFSET InBuffer     ;es:di zeigen auf InBuffer[0]
	mov	si, di                  ;ds:si zeigen auf InBuffer[InPos]
	add	si, [InPos]
	mov	cx, 65534
	sub	cx, [InPos]
	push	ds			;ds sichern
	mov	ax, SEG InBuffer
	mov	es, ax
	mov	ds, ax
	cld				;Richtung: ------->
	rep	movsb
	pop	ds			;ds zurck


	mov	ax, OFFSET InBuffer+65534
	sub	ax, [InPos]
	READ [@@InHandle], ax, <SEG InBuffer>, [InPos]

	jmp	@@NextBlock		;nchsten Block packen!


@@EndUnPack:
	pop	si			;Regs zurck
	pop	di
	pop	ds
	mov	sp, bp			;Stack zurck
	pop	bp
	ret
ENDP

;************************************************************************
;  UnPackOneFile (int InHandle, int OutHandle)                          *
;-----------------------------------------------------------------------*
; Entpackt die Datei spezifiziert durch InHandle, in die Datei OutHandle*
;************************************************************************

PROC	_UnPackOneFile
	ARG	@@InHandle: WORD, @@OutHandle: WORD

	push	bp    			;Stack vorbereiten
	mov	bp, sp

;---------------- Vorbereitung -----------------
       ;------ bersetungsdaten einlesen -------
	READ [@@InHandle], <OFFSET FileTbl>, <SEG FileTbl>, 132
			;Dateilnge jetzt in FileTbl[0]

       ;----- bersetzungstabelle erstellen ------
				;CreateUnPackTbl (&FileTbl, &UnPackTbl)
	CREATEUNPACKTBL <OFFSET FileTbl+4>, ds, <OFFSET TransTbl>, ds

;--------------- Entpacke Datei ----------------
	UNPACKFILE2FILE [@@InHandle], [@@OutHandle], <[WORD FileTbl]>, <[WORD FileTbl+2]>, <OFFSET TransTbl>, <SEG TransTbl>

	pop	bp
	ret				;Ende
ENDP

;******************************************************************
;******************************************************************
;******************************************************************

	END
